## grandorgue 3.16.2

=== debian/changelog ===
grandorgue (3.16.2-1) unstable; urgency=medium

  * New upstream version 3.16.2

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 16 Nov 2025 21:23:17 +0100
