=== debian/changelog ===
grandorgue (3.16.3-1) unstable; urgency=medium

  * New upstream version 3.16.3
  * Drop “Priority: optional”, which is now the default
  * Bump Standards-Version to 4.7.3

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 29 Dec 2025 11:47:24 +0100
