=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: grandorgue
 Maintainer: Sébastien Villemot <sebastien@debian.org>
 Section: sound
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libjack-dev,
@@ -24,7 +23,7 @@
                zip,
                po4a
 Build-Conflicts: graphicsmagick-imagemagick-compat
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/grandorgue
 Vcs-Git: https://salsa.debian.org/debian/grandorgue.git
 Homepage: https://github.com/GrandOrgue/grandorgue
