=== debian/changelog ===
grandorgue (3.17.0-1) unstable; urgency=medium

  * New upstream version 3.17.0
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 15 Feb 2026 11:32:45 +0100
